EDIT - feature request #9502

Implement subarea preference rule and fallback areas for areas with complex hierarchy
03/02/2021 07:31 PM - Andreas Mdller

Status: Resolved Start date:

Priority: Highest Due date:

Assignee: Andreas Muller % Done: 90%
Category: cdmlib Estimated time: 0:00 hour
Target version: Release 5.39

Severity: normal

Description

#5050 defines the subarea preference rule and also describes implements it for areas Ju, Cz, IJ and LS which are relatively easy to
handle in the hierarchy.

Some more areas are more difficult to handle:

ent => fixed by #9521

GCm{(stil-to-decide-if-the-hierarchy-sheuld-stay-as-it-is} => fixed by #9521, UK => UC, UK(K) => UK, UC becomes fallback-area
¢ NEW: handling of Turkey parts where Tu has EUR as parent and at the same time is direct child of E+R (or Non-EUR). Tu(A)
should be only child of the later while Tu(E) should be only child of the former => copied to #10350

Most of these issues can be solved by using a term tree (of areas). This will also make hidden areas obsolet (they simply do not
appear in the tree).
Fallback areas should then be marked in the tree not in the area (as it is a publication decision not a data property).

=> for-this-we-heed-to-make TermNode-annetatable done (#10320, #10335)

Areas with >1 parents can be handled twice in the tree (allowDuplicates=true).

A problem with this solution might be the ordering. If ordered via the natural tree order areas may show up at the wrong place if they
have fallback parents.

Maybe this can be solved by having fallback children >1x in the tree. Once at the correct position and once with at the fallback parent
position with a convention that the fallback position is only for computation of the fallback area, not for handling the subarea itself.
The children list then can always be flat (e.g. in case of Ju/CM).

See also duplicate #9486
The remaining issues are probably blocked by #6794

A remaining issue is also to allow area trees in CdmLightClassification-, CsvName- and WordClassificationExport. Currently it is set
to null there.

Related issues:

Related to EDIT - task #8671: Distribution in E+M (BM) on different levels Rejected
Related to EDIT - bug #8297: Fix condensed distribution string for E+M Closed
Related to EDIT - feature request #9500: Allow removing certain distribution ... Feedback
Related to EDIT - feature request #5050: revise the subAreaPreference rule fo... Closed
Related to EDIT - feature request #3904: EuroMed: Implement filtering rules f... Closed
Related to EDIT - bug #4409: fallback areas are not adressable in the shape file Closed
Related to EDIT - bug #8310: Issues to solve in E+M shapefile Closed
Related to EDIT - bug #9367: E+M shapefile Baltic subarea borders always visi... New
Related to EDIT - bug #7107: "Omit level" (TDWG Level2) in distribution hiera... Discussed
Related to EDIT - feature request #9521: Fallback areas in textual representa... Closed
Related to EDIT - feature request #6794: Improve term structure In Progress
Related to EDIT - bug #9526: Sort order in E+M distribution string should be ... Closed
Related to EDIT - task #10308: Show IUCN "distribution" data separately Closed
Related to EDIT - feature request #10320: MakeTermRelationBase annotatable Closed

Related to EDIT - feature request #10335: Allow editing supplemental data for... Closed
Related to EDIT - feature request #9503: Handle term tree of areas and distri... Closed
Related to EDIT - feature request #10327: IUCN condensed distribution configu... Closed
Related to EDIT - bug #10346: Bugs in E+M dataportal 5.38 Closed
Related to EDIT - feature request #10349: Add Gr+AE(G) und Russian aereas for... New

Has duplicate EDIT - bug #9486: Fallback areas not handled in area hierarchy ... Duplicate
Copied to EDIT - feature request #10350: Implement distribution algorithms to... New

Associated revisions

Revision 1c8d2a40 - 04/28/2023 12:55 PM - Katja Luther

ref #10308: add possibility to choose a area tree

Revision 051aa0a3 - 04/28/2023 01:13 PM - Katja Luther

ref #10308: add possibility to choose a area tree and use it in ws

Revision 494c3d5d - 04/28/2023 01:14 PM - Katja Luther

ref #10308: add possibility to choose a area tree and use it in ws -deactivated

Revision 37708b03 - 04/28/2023 01:38 PM - Andreas Miiller
ref #9502, ref #9503, ref #10308

Revision f1e65bf3 - 04/29/2023 12:45 AM - Andreas Miiller
ref #9502, ref #9503, ref #10308 use areaTree in distributioninfo

Revision 3540279 - 05/02/2023 10:48 AM - Andreas Miiller
ref #9502, ref #9503, ref #10308 add @transient to getParentMap

Revision ff3b3489 - 05/02/2023 12:28 PM - Andreas Muller
ref #9502, ref #9503, ref #10308 fix areaTreeUuid is missing

Revision bOb71d13 - 06/13/2023 10:13 AM - Andreas Miiller

ref #9502 add second method for loading distribution tree based on term tree (incl. annotations)

Revision 02d8cf93 - 06/13/2023 10:45 AM - Andreas Miiller

ref #9502 add second method for loading distribution tree based on term tree (incl. annotations) - fix NPE

Revision f426088c - 06/13/2023 12:34 PM - Andreas Miiller
ref #9502 fix handling for multiple parents in distribution filter

Revision fadae8f5 - 06/14/2023 01:58 AM - Andreas Miiller
ref #9502 fix handling for multiple parents in distribution filter (try to fix test)

Revision cfaa3fc2 - 06/14/2023 02:00 AM - Andreas Miiller

ref #9502 try to implement multiple parents for CondensedDistributionComposer (still needs cleanup)

Revision 8ac72493 - 06/14/2023 02:15 AM - Andreas Miiller

ref #9502 fix handling for multiple parents in distribution filter (continue fix)

Revision ec4f182d - 06/14/2023 02:37 AM - Andreas Miiller

ref #9502 try to implement multiple parents for CondensedDistributionComposer (fix Cuba tests and some cleanup)

Revision 71b97524 - 06/14/2023 10:44 AM - Andreas Miiller

ref #9502 remove tests without value (computed marker)

History
#1 - 03/02/2021 07:34 PM - Andreas Miiller
- Related to task #8671: Distribution in E+M (BM) on different levels added

#2 - 03/02/2021 07:37 PM - Andreas Miiller
- Related to bug #8297: Fix condensed distribution string for E+M added

#3 - 03/02/2021 07:37 PM - Andreas Miiller

- Related to feature request #9500: Allow removing certain distribution status from distribution publication added

#4 - 03/02/2021 07:37 PM - Andreas Miiller

- Related to feature request #5050: revise the subAreaPreference rule for filtering Distributions added

#5 - 03/02/2021 07:41 PM - Andreas Miiller

- Related to feature request #3904: EuroMed: Implement filtering rules for distributions added

#6 - 03/02/2021 07:50 PM - Andreas Miiller
- Related to bug #4409: fallback areas are not adressable in the shape file added

#7 - 03/02/2021 07:50 PM - Andreas Miiller
- Related to bug #8310: Issues to solve in E+M shapefile added

#8 - 03/02/2021 07:51 PM - Andreas Miiller

- Related to bug #9367: E+M shapefile Baltic subarea borders always visible and remove Georgian subdivisions added

#9 - 03/02/2021 07:52 PM - Andreas Miiller

- Has duplicate bug #9486: Fallback areas not handled in area hierarchy are not showing up correctly if subarea data exists added

#10 - 03/02/2021 07:52 PM - Andreas Miiller
- Description updated

#11 - 03/02/2021 08:00 PM - Andreas Miiller

- Blocks feature request #9503: Handle term tree of areas and distribution status for distributioninfo in dataportal added

#12 - 03/02/2021 08:19 PM - Andreas Miiller
AM:

Problematisch sind derzeit ja noch die Fallback-Areale, die viele Hierarchiestufen haben oder Uberlappen. Also konkret

* Bt, wegen der doppelten Zugehérigkeit von Rf(K) zu Bt und Rf

« Cc, wegen der doppelten Zugehérigkeit von Rf(CS) und wegen der mehrfachen Hierarchie
» SM, wegen der mehrfachen Hierarchie

» Cm, wegen der doppelten Zugehdrigkeit zu Uk und Rf

Erstmal zu den Mehrfachzugehdrigkeiten:

Ich gehe davon aus, dass Bt im CondensedDistributionString nur angezeigt werden soll, wenn weder Rf(K) noch ein anderes Subareal Daten hat.
Und Rf(K) wird immer als Subareal von Rf angezeigt. Bt wird in der textuellen Darstellung dann angezeigt, wenn es Quellen besitzt, auch wenn es fur
die Subareale Daten gibt. Die Subareale werden dann aber selbstandig angezeigt, nicht in Klammern hinter Bt.

Gleiches wie fur Bt und Rf(K) gilt fir Cc und Rf(CS).

Bei Cm ist es derzeit noch anders. Dies hat zwar ein neues Label, wird derzeit aber noch genauso behandelt, wie ein normales Unterareal von Uk.
Zudem hat es keinen Einfluss auf Rf (zudem es ja theoretisch ebenfalls Unterareal ist). Soll das erstmal so bleiben?

Zu den mehrfach Hierarchien:

Die Hierarchie von SM ist derzeit noch nicht richtig dargestellt. Das wére aber leicht machbar. Ich wirde dann von folgender Regel ausgehen. Wenn
es Daten flir Ko oder Se gibt, wird Sr nicht angezeigt im CondDistrStr bzw. nur als selbstandiges Areal mit Quellen im Volltext. Entsprechend, wenn
Sr oder Cg Daten hat (Sr als Fallback oder vertreten durch Ko und Se), dann wird SM nicht angezeigt im CondDistrStr bzw. nur als selbstandiges
Areal mit Quellen im Volltext. Entsprechend fiir SM und alle Unterareale von Ju.

Entsprechendes gilt dann auch fir Cc, Tcs, Ab, Ar, Gg + Unterareale von Ab und Gg, aber mit der Ausnahme, dass Ab und Gg immer angezeigt

werden, nicht nur wenn es keine Daten fir die Unterareale gibt. Und mit der Besonderheit, dass Cc im CondDistrStr nur angezeigt wird, wenn auch
Rf(CS) keine Daten hat, da es nicht nur Unterareal von Rf sondern auch von Cc ist.
Dies sollte dann zur Folge haben, dass fur Ju immer nur eine Hierarchiestufe angezeigt wird, keine Klammern, weder im CondDistrStr noch in der
textuellen Darstellung.

Beim Kaukasus hingegen werden Ab(X) und Gg(X) auf zweiter Hierarchiestufe angezeigt, alle anderen ebenfalls nur auf der ersten Stufe, egal ob das
dartiberliegende Areal Daten besitzt (die dann ja ausgeblendet werden, bis auf die Quellen).

Eigentlich scheint mir das alles so jetzt recht logisch bis auf den Krim-Fall. Trotzdem wére es gut, wenn du es nochmal bestétigst.

#13 - 03/02/2021 08:35 PM - Andreas Miiller

- Related to bug #7107: "Omit level" (TDWG Level2) in distribution hierarchy should not supress distributions source reference added

#14 - 03/06/2021 01:52 PM - Andreas Miiller

- Related to feature request #9521: Fallback areas in textual representation should always stand alone added

#15 - 03/07/2021 12:25 PM - Andreas Miiller

ERS:

mir scheint, Du hast die Probleme nun richtig erfasst und dargestellt.

Zur Krim:

Eigentlich ist gewlinscht, dies als eigenes, rein geographisch definiertes Unterareal ohne Bezug zu einem Uberareal — weder Ukraine noch Russland-
darzustellen. Analog wie Sardinien oder Korsika, die ja per se ebenfalls keine Bezlige zu ltalien bzw. Frankreich haben. Wollte man etwa eine

Checkliste Italiens inclusive Sardiniens und Siziliens erstellen, miisste man dies gesondert kalkulieren.

Bisher hatten wir Krim noch als Unterareal der Ukraine belassen, weil wir ja noch sehr viele Daten fur Uk (Ukraine with Crimea) haben, vor allem aus
der Checkliste der gesamten Ukraine. Ich dachte, so wére der Zusammenhang besser sichtbar, aber vielleicht muss das nicht sein.

Wir hatten dann Crimea Cm, Ukraine Uk(U) und Ukraine, with Crimea Uk jeweils als eigene Areale. Wenn Crimea kein Unterareal der Ukraine with
Crimea mehr sein soll, ist es verwirrend, wenn Uk(U) immer noch Unterareal von Uk ist. Eine rein logische Lésung kénnte sein, Uk in UC
umzubenennen (Ukraine+Crimea) und Uk(U) in Uk (Ukraine without Crimea)...

AM:

ja, ich denke die Umbennung in UC macht Sinn. Ich denke, das ist dann auch die Lésung. Wir machen UC nach der Umbennung zu einem
Fallback-Areal, es wird im CondDistrStr also nur angezeigt, wenn keine Daten auf Unterareal-Ebene existieren. Im Text werden die Areale auch
gleicher Ebene angezeigt (sofern Daten existieren). In den Karten bleibt es wie es ist, UC wird nur angezeigt, wenn keine Unterareal-Daten

existieren.
Das ist dann &hnlich wie bei Ju, SM, Sr, Bt, IJ, etc.

#16 - 03/07/2021 12:47 PM - Andreas Miiller

- Description updated
All issues not related to areas with direct multiple parents are fixed with #9521. Now deeper hierarchies with multiple fallback areas are possible.

#17 - 03/11/2021 10:47 AM - Andreas Miiller

- Related to feature request #6794: Improve term structure added

#18 - 03/11/2021 10:48 AM - Andreas Miiller

- Description updated

#19 - 03/12/2021 12:06 PM - Andreas Miiller
- Related to bug #9526: Sort order in E+M distribution string should be strictly alphabetic added

#20 - 04/16/2021 09:54 PM - Andreas Miiller

- Target version changed from Release 5.22 to Release 5.46

#21 - 04/28/2023 01:35 PM - Andreas Miiller
- Related to task #10308: Show IUCN "distribution" data separately added

#22 - 04/28/2023 11:12 PM - Andreas Miiller

- Description updated

#23 - 04/28/2023 11:23 PM - Andreas Miiller

- Description updated
- Status changed from New to In Progress

- % Done changed from 0 to 30

#24 - 05/27/2023 11:04 PM - Andreas Miiller

- Target version changed from Release 5.46 to Release 5.44

#25 - 05/28/2023 01:06 PM - Andreas Miiller

- Related to feature request #10320: Make TermRelationBase annotatable added

#26 - 05/28/2023 01:09 PM - Andreas Miiller
- Related to feature request #10335: Allow editing supplemental data for TermNodes added

#27 - 05/30/2023 08:37 PM - Andreas Miiller

- Description updated

#28 - 06/01/2023 12:34 PM - Andreas Miiller

- Blocks deleted (feature request #9503: Handle term tree of areas and distribution status for distributioninfo in dataportal)

#29 - 06/01/2023 12:34 PM - Andreas Miiller

- Related to feature request #9503: Handle term tree of areas and distribution status for distributioninfo in dataportal added

#30 - 06/02/2023 04:16 PM - Andreas Miiller
- Related to feature request #10327: IUCN condensed distribution configuration added

#31 - 06/08/2023 12:24 AM - Andreas Miiller

- Description updated

#32 - 06/08/2023 01:35 AM - Andreas Miuiller

- Description updated

#33 - 06/10/2023 11:36 AM - Andreas Miuiller

- Description updated

#34 - 06/13/2023 09:45 AM - Andreas Miiller
- Related to bug #10346: Bugs in E+M dataportal 5.38 added

#35 - 06/14/2023 11:16 AM - Andreas Miiller
- Status changed from In Progress to Resolved

- % Done changed from 30 to 70

This is probably fully fixed (except for the new issue of Tu which should go to another ticket).

#36 - 06/14/2023 05:02 PM - Andreas Miiller

- Target version changed from Release 5.44 to Release 5.39

#37 - 06/15/2023 09:38 AM - Andreas Miiller
- Description updated

#38 - 06/15/2023 09:46 AM - Andreas Miiller
- Related to feature request #10349: Add Gr+AE(G) und Russian aereas for mosses to the E+M shapefile added

#39 - 06/15/2023 10:14 AM - Andreas Miiller
- Copied to feature request #10350: Implement distribution algorithms to work with Tu, Tu(E) and Tu(A) in Euro+Med added

#40 - 06/15/2023 10:16 AM - Andreas Muller

- Description updated
- % Done changed from 70 to 90

still need to cleanup code and copy remaining issues.
